'use strict';'require view';'require dom';'require ui';'require form';'require poll';'require rpc';'require fs';'require uci';const machineTypes=['Pump','Power','Rail','PLC'];const manufacturer_types=['OEM','Retrofit',];const power_fields=['port','loadtype','cttype','isostat','phasetype','subtype'];const pump_fields=['type','mac'];const plc_fields=['port'];var st_fields=['index','mac','type'];const pump_models=['VPDB-10_V3','SVP-5_V3'];var fullMac=null;document.querySelector('head').appendChild(E('link',{'rel':'stylesheet','type':'text/css','href':L.resource('view/novatec-machines/css/custom.css')}));var callGetMac=L.rpc.declare({object:'network.device',method:'status',params:['name'],expect:{}});var callBleScan=L.rpc.declare({object:'ble',method:'scan',expect:{}});var subtype_options={'pump':['Pump','Cassette Motor','Cassette Chain','Regen Blower','Process Blower','CDA PS','Component Analyzer'],'power':['HeaterSense','MotorSense','EnergySense','VFDSense','Regen Heater','CDA PF',],'rail':['Rail'],'plc':['PLC']};var v_factor_limit=10;var novatec_sensors=[];var updateSensorID=function(section_id,mac_addr,sensor_type,index){var type=sensor_type==''?uci.get('machines',section_id,'type'):sensor_type;var mac=mac_addr==''?uci.get('machines',section_id,'mac'):mac_addr;if(!mac||!type){return;}
mac=mac.replace(/:/g,'').toLowerCase();var sensorIndex=index||1;var sensor_id=mac+'_'+type+'_'+sensorIndex;uci.set('machines',section_id,'id',sensor_id);if(sensor_id){var novatec_sensor=novatec_sensors.find((sensor)=>sensor['.name']==sensor_id);if(novatec_sensor){var calib_keys=Object.keys(novatec_sensor);for(var j=0;j<calib_keys.length;j++){if(calib_keys[j].indexOf('.')==-1){uci.set('machines',section_id,calib_keys[j],novatec_sensor[calib_keys[j]]);}}}}}
function machineIdsFixed(){if(document.getElementById('cbi-machines-machine')){var machineArray=[];var machineValues=[];var nodes=document.getElementById('cbi-machines-machine').childNodes;for(var i=0;i<nodes.length;i++){if(nodes[i].getAttribute('data-section-id'))
machineArray.push(nodes[i].getAttribute('data-section-id'));}
if(machineArray.length>0){for(var i=0;i<machineArray.length;i++){machineValues[i]=uci.get('machines',machineArray[i],'id');}
var sensors=uci.sections('machines','sensor');for(var i=0;i<machineArray.length;i++){var noSensors=true;for(var j=0;j<sensors.length;j++){if(sensors[j]['machine']==machineValues[i]){noSensors=false;}}
if(!noSensors){document.getElementById('widget.cbid.machines.'+machineArray[i]+'.id').readOnly=true;}}}
return true;}
return false;}
var getSensors=function(machines){var sensors=uci.sections('machines','sensor');var machineSensors=[];for(var i=0;i<machines.length;i++){for(var j=0;j<sensors.length;j++){if(sensors[j]['machine']==machines[i].id){if(machineSensors[machines[i].id]==undefined){machineSensors[machines[i].id]=[];}
machineSensors[machines[i].id].push(sensors[j]);}}}
return machineSensors;}
var disablePortOptions=function(){var machines=uci.sections('machines','machine');var powerMachines=machines.filter(function(machine){return machine.type=='power';});var plcMachines=machines.filter(function(machine){return machine.type=='plc';});var powerSensors=getSensors(powerMachines);var plcSensors=getSensors(plcMachines);disableSensorPorts(powerSensors);disableSensorPorts(plcSensors);}
var disableSensorPorts=function(sensors){for(var machineId in sensors){for(var i=0;i<sensors[machineId].length;i++){var portEl=document.getElementById('cbi-machines-'+sensors[machineId][i]['.name']+'-port');if(portEl){var portOptions=portEl.querySelectorAll('option');if(portOptions){for(var j=0;j<portOptions.length;j++){if(String(portOptions[j].value)!=String(sensors[machineId][i]['port'])){for(var k=0;k<sensors[machineId].length;k++){if(String(portOptions[j].value)==String(sensors[machineId][k]['port'])){portOptions[j].disabled='disabled';}}}}}}}}}
var disableIndexOptions=function(){var machines=uci.sections('machines','machine');var railMachines=machines.filter(function(machine){return machine.type=='rail';});var railSensors=getSensors(railMachines);for(var machineId in railSensors){for(var i=0;i<railSensors[machineId].length;i++){var indexEl=document.getElementById('cbi-machines-'+railSensors[machineId][i]['.name']+'-index');if(indexEl){var indexOptions=indexEl.querySelectorAll('option');if(indexOptions){for(var j=0;j<indexOptions.length;j++){if(indexOptions[j].value!=railSensors[machineId][i]['index']){for(var k=0;k<railSensors[machineId].length;k++){if(indexOptions[j].value==railSensors[machineId][k]['index']){indexOptions[j].disabled='disabled';}}}}}}}}}
var fireSensorScripts=function(){disablePortOptions();disableIndexOptions();}
var fireLoadingScripts=function(){machineIdsFixed();}
var updateSensors=function(){var sensors=uci.sections('machines','sensor');for(var i=0;i<sensors.length;i++){if(!sensors[i]['id']){var index=sensors[i]['port']!=''?sensors[i]['port']:sensors[i]['index']!=''?sensors[i]['index']:1;updateSensorID(sensors[i]['.name'],'','',index);}}}
var addSubtypeOptions=function(section_id,value){var subtype_select=document.getElementById('widget.cbid.machines.'+section_id+'.subtype');var current_subtype=uci.get('machines',section_id,'subtype');var final_option_count=1;var remove_option=1;while(subtype_select.options.length>final_option_count){if(!subtype_select.options[remove_option].selected){subtype_select.options.remove(remove_option);}else{remove_option++;final_option_count++;}}
for(var i=0;i<subtype_options[value].length;i++){if(!current_subtype||(current_subtype&&subtype_options[value][i].toLowerCase().replace(/ /g,'_')!=current_subtype)){subtype_select.options[subtype_select.options.length]=new Option(subtype_options[value][i],subtype_options[value][i].toLowerCase().replace(/ /g,'_'));}}}
return view.extend({load:async function(){await fs.read('/etc/config/machines').catch(()=>{fs.write('/etc/config/machines',' ');});await fs.read('/etc/config/gaugerules').catch(()=>{fs.write('/etc/config/gaugerules',' ');});await fs.read('/etc/config/novatec_sensors').catch(()=>{fs.write('/etc/config/novatec_sensors',' ');});await fs.read('/etc/config/baselines').catch(()=>{fs.write('/etc/config/baselines',' ');});return Promise.all([uci.load('gaugerules'),uci.load('machines'),uci.load('novatec_sensors'),uci.load('baselines')]).then(()=>{novatec_sensors=uci.sections('novatec_sensors','sensor');});},handleReset:function(){fireLoadingScripts();},handleSave:function(){var tasks=[];document.getElementById('maincontent').querySelectorAll('.cbi-map').forEach(function(map){var mapFunction=()=>{fireLoadingScripts();updateSensors();}
tasks.push(DOM.callClassMethod(map,'save',mapFunction));});return Promise.all(tasks);},render:async function(){var m,s,o,ss;m=new form.Map('machines',_('Machines'),_('Add/Edit/Remove Machines from your device.'));m.readonly=!L.hasViewPermission();s=m.section(form.TypedSection,'machine');s.anonymous=true;s.addremove=true;s.addbtntitle=_('Add Machine');s.has_gaugerules=false;s.has_baselines=false;s.load=function(){var gaugerules=uci.sections('gaugerules','rule');if(gaugerules.length){s.has_gaugerules=true;}else{s.has_gaugerules=false;}
var baselines=uci.sections('baselines','baseline');if(baselines.length){s.has_baselines=true;}else{s.has_baselines=false;}
machineIdsFixed();return Promise.all([callGetMac('eth0'),uci.sections('machines','machine')]).then(L.bind(function(data){fullMac=data[0].macaddr;this.mac=data[0].macaddr.replace(/:/g,'');this.machines=data[2];},this));}
s.modaltitle=function(section_id){if(section_id.indexOf('new')>-1){return _('New Machine');}
return _('Machines')+' » '+uci.get('machines',section_id,'id');};s.renderRowActions=function(section_id){var tdEl=this.super('renderRowActions',[section_id,_('Edit')])
return tdEl;};s.handleRemove=function(section_id,ev){var machine_id=uci.get('machines',section_id,'id');var sensors=uci.sections('machines','sensor');for(var i=0;i<sensors.length;i++){if(sensors[i]['machine']==machine_id){uci.remove('machines',sensors[i]['.name']);}}
if(s.has_gaugerules){var gaugerules=uci.sections('gaugerules','rule');for(var i=0;i<gaugerules.length;i++){if(gaugerules[i]['machine_id']==machine_id){uci.remove('gaugerules',gaugerules[i]['.name']);}}}
if(s.has_baselines){var baselines=uci.sections('baselines','baseline');for(var i=0;i<baselines.length;i++){if(baselines[i]['machine_id']==machine_id){uci.remove('baselines',baselines[i]['.name']);}}}
uci.remove('machines',section_id);uci.save();document.querySelector('#cbi-machines-'+section_id).remove();document.querySelector('.cbi-button[name="cbi.rts.machines.'+section_id+'"]').parentElement.remove();};s.handleAdd=function(ev){return this.map.save(L.bind(function(){var currentTimestamp=Date.now();var machineName='machine-'+this.mac+'-'+currentTimestamp.toString(16);var newMachine=uci.add('machines','machine');uci.set('machines',newMachine,'id',machineName);setTimeout(function(){fireLoadingScripts();},1000);},this));};s.showScanModal=function(mac,machine,ev){var table=E('table',{'class':'table'},[E('tr',{'class':'tr table-titles'},[E('th',{'class':'th col-2 middle left'},_('UUID')),E('th',{'class':'th col-4 middle left'},_('Name')),E('th',{'class':'th col-4 middle left'},_('MAC')),E('th',{'class':'th col-2 middle left'},_('RSSI')),E('th',{'class':'th cbi-section-actions right'},' ')])]);var stop=E('button',{'class':'btn','click':L.bind(this.handleScanStartStop,this),'style':'display:none','data-state':'stop'},_('Stop refresh'));startSpinner();var md=ui.showModal(_('Add Bluetooth Device'),[table,E('div',{'class':'right'},[stop,' ',E('button',{'class':'btn','click':L.bind(this.handleScanAbort,this)},_('Dismiss'))])]);md.style.maxWidth='90%';md.style.maxHeight='none';this.pollFn=L.bind(this.handleScanRefresh,this,mac,machine,table,stop);poll.add(this.pollFn,1);poll.start();};s.handleScan=function(mac,machine,ev){s.showScanModal(mac,machine,ev);};s.handleScanRefresh=function(mac,machine,table,stop){return callBleScan().then(L.bind(function(results){var rows=[];if(results.ble_list==[]||(this.ble_list&&results.ble_list.length<this.ble_list.length)){results.ble_list=this.ble_list;}
results=results.ble_list;this.ble_list=results;results.sort(function(a,b){if(a.addr<b.addr)
return-1;else if(a.addr>b.addr)
return 1;});for(var i=0;i<results.length;i++){var res=results[i];rows.push([E('span',{},'%h'.format(res.uuid)),E('span',{},'%h'.format(res.name)),E('span',{},'%h'.format(res.addr)),E('span',{},'%h'.format(res.rssi)),E('div',{'class':'right'},E('button',{'class':'cbi-button cbi-button-action important','click':ui.createHandlerFn(this,'handleJoinConfirm',mac,machine,res)},_('Add Device')))]);res.stale=true;}
cbi_update_table(table,rows);stop.disabled=false;stop.style.display='';stop.classList.remove('spinning');stopSpinner();},this));};s.handleScanStartStop=function(ev){var btn=ev.currentTarget;if(btn.getAttribute('data-state')=='stop'){poll.remove(this.pollFn);btn.firstChild.data=_('Start refresh');btn.setAttribute('data-state','start');}
else{poll.add(this.pollFn);btn.firstChild.data=_('Stop refresh');btn.setAttribute('data-state','stop');btn.classList.add('spinning');btn.disabled=true;}};s.handleScanAbort=function(ev){var md=dom.parent(ev.target,'div[aria-modal="true"]');if(md){md.style.maxWidth='';md.style.maxHeight='';}
ui.hideModal();poll.remove(this.pollFn);this.pollFn=null;};s.handleJoinConfirm=function(mac_type,section_id,device,ev){poll.remove(this.pollFn);var deviceMac=device.addr;return this.map.save(function(){if(mac_type=='mac'){var type=uci.get('machines',section_id,'type')||'';updateSensorID(section_id,device.addr,type);}
uci.set('machines',section_id,mac_type,deviceMac);}).then(L.bind(function(){ui.hideModal();setTimeout(function(){fireLoadingScripts();},1000);}),this);};o=s.option(form.Value,'id',"Machine ID");o.modalonly=false;o.cfgvalue=function(section_id){return uci.get('machines',section_id,'id');}
o=s.option(form.Value,'name',_('Name'));o.modalonly=false;o.cfgvalue=function(section_id){return uci.get('machines',section_id,'name');}
o=s.option(form.ListValue,'manufacturer_type',_('Manufacturer Type'));o.modalonly=false;o.value('',_('Select Manufacturer Type'));for(var i=0;i<manufacturer_types.length;i++){o.value(manufacturer_types[i].toLowerCase(),manufacturer_types[i]);}
o.onchange=function(ev,section_id,value){uci.set('machines',section_id,'manufacturer_type',value);setTimeout(function(){fireLoadingScripts();},1000);}
o.cfgvalue=function(section_id){return uci.get('machines',section_id,'manufacturer_type');}
o.validate=function(section_id,value){if(value==''){return _('Select Manufacturer Type');}else{return true;}}
o=s.option(form.ListValue,'type',_('Type'));o.modalonly=false;o.value('',_('Select Machine Type'));for(var i=0;i<machineTypes.length;i++){o.value(machineTypes[i].toLowerCase(),machineTypes[i]);}
o.onchange=function(ev,section_id,value){uci.set('machines',section_id,'type',value);setTimeout(function(){fireLoadingScripts();},1000);}
o.cfgvalue=function(section_id){return uci.get('machines',section_id,'type');}
o.validate=function(section_id,value){if(value==''){return _('Select Machine Type');}else{return true;}}
o=s.option(form.ListValue,'subtype_pump',_('Sub Type'));o.modalonly=false;o.depends('type','pump');o.value('',_('Select Sub Type'));for(var j=0;j<subtype_options['pump'].length;j++){o.value(subtype_options['pump'][j].toLowerCase().replace(/ /g,'_'),subtype_options['pump'][j]);}
o.cfgvalue=function(section_id){return uci.get('machines',section_id,'subtype_pump');}
o.onchange=function(ev,section_id,value){if(value!=''){this.map.save(function(){uci.set('machines',section_id,'subtype_pump',value);uci.set('machines',section_id,'subtype',value);}).then(()=>{setTimeout(function(){fireLoadingScripts();},1000);});}};o.validate=function(section_id,value){if(value==''&&uci.get('machines',section_id,'type')){return _('Select Sub Type');}else{return true;}}
o=s.option(form.ListValue,'subtype_power',_('Sub Type'));o.modalonly=false;o.depends('type','power');o.value('',_('Select Sub Type'));for(var j=0;j<subtype_options['power'].length;j++){o.value(subtype_options['power'][j].toLowerCase().replace(/ /g,'_'),subtype_options['power'][j]);}
o.cfgvalue=function(section_id){return uci.get('machines',section_id,'subtype_power');}
o.onchange=function(ev,section_id,value){if(value!=''){this.map.save(function(){uci.set('machines',section_id,'subtype_power',value);uci.set('machines',section_id,'subtype',value);}).then(()=>{setTimeout(function(){fireLoadingScripts();},1000);});}};o.validate=function(section_id,value){if(value==''&&uci.get('machines',section_id,'type')&&uci.get('machines',section_id,'pump_model')){return _('Select Sub Type');}else{return true;}}
o=s.option(form.ListValue,'subtype_rail',_('Sub Type'));o.modalonly=false;o.depends('type','rail');o.value('',_('Select Sub Type'));for(var j=0;j<subtype_options['rail'].length;j++){o.value(subtype_options['rail'][j].toLowerCase().replace(/ /g,'_'),subtype_options['rail'][j]);}
o.cfgvalue=function(section_id){return uci.get('machines',section_id,'subtype_rail');}
o.onchange=function(ev,section_id,value){if(value!=''){this.map.save(function(){uci.set('machines',section_id,'subtype_rail',value);uci.set('machines',section_id,'subtype',value);}).then(()=>{setTimeout(function(){fireLoadingScripts();},1000);});}};o.validate=function(section_id,value){if(value==''&&uci.get('machines',section_id,'type')){return _('Select Sub Type');}else{return true;}}
o=s.option(form.ListValue,'subtype_plc',_('Sub Type'));o.modalonly=false;o.depends('type','plc');o.value('',_('Select Sub Type'));for(var j=0;j<subtype_options['plc'].length;j++){o.value(subtype_options['plc'][j].toLowerCase().replace(/ /g,'_'),subtype_options['plc'][j]);}
o.cfgvalue=function(section_id){return uci.get('machines',section_id,'subtype_plc');}
o.onchange=function(ev,section_id,value){if(value!=''){this.map.save(function(){uci.set('machines',section_id,'subtype_plc',value);uci.set('machines',section_id,'subtype',value);}).then(()=>{setTimeout(function(){fireLoadingScripts();},1000);});}};o.validate=function(section_id,value){if(value==''&&uci.get('machines',section_id,'type')){return _('Select Sub Type');}else{return true;}}
o=s.option(form.ListValue,'k_factor',_('K Factor'));o.modalonly=false;o.depends({type:'power',subtype:'heatersense'});o.depends({type:'power',subtype:'energysense'});o.depends({type:'power',subtype:'motorsense'});o.depends({type:'power',subtype:'vfdsense'});o.depends({type:'power',subtype_power:'heatersense'});o.depends({type:'power',subtype_power:'energysense'});o.depends({type:'power',subtype_power:'motorsense'});o.depends({type:'power',subtype_power:'vfdsense'});for(var i=1;i<=v_factor_limit;i++){o.value(i,i);}
o.cfgvalue=function(section_id){return uci.get('machines',section_id,'k_factor');}
o=s.option(form.Value,'pump_number',_('Pump Number'));o.modalonly=false;o.load=function(section_id){}
o.cfgvalue=function(section_id){return uci.get('machines',section_id,'pump_number');}
o.depends({type:'pump',subtype:'pump'});o.depends({type:'pump',subtype_pump:'pump'});o.validate=function(section_id,value){if(value!=''&&!Number.isInteger(+value)){return _('Whole numbers only');}else{return true;}}
o=s.option(form.Value,'blower_type',_('Blower Type'));o.modalonly=false;o.load=function(section_id){}
o.cfgvalue=function(section_id){return uci.get('machines',section_id,'blower_type');}
o.depends({type:'pump',subtype:'pump'});o.depends({type:'pump',subtype_pump:'pump'});o=s.option(form.Value,'vendor_name',_('Vendor Name'));o.modalonly=false;o.load=function(section_id){}
o.cfgvalue=function(section_id){return uci.get('machines',section_id,'vendor_name');}
o.depends({type:'pump',subtype:'pump'});o.depends({type:'pump',subtype_pump:'pump'});o=s.option(form.Value,'blower_model',_('Blower Model'));o.modalonly=false;o.load=function(section_id){}
o.cfgvalue=function(section_id){return uci.get('machines',section_id,'blower_model');}
o.depends({type:'pump',subtype:'pump'});o.depends({type:'pump',subtype_pump:'pump'});o=s.option(form.Value,'blower_serial_number',_('Blower Serial Number'));o.modalonly=false;o.load=function(section_id){}
o.cfgvalue=function(section_id){return uci.get('machines',section_id,'blower_serial_number');}
o.depends({type:'pump',subtype:'pump'});o.depends({type:'pump',subtype_pump:'pump'});o=s.option(form.ListValue,'pump_model',_('Pump Model'));o.modalonly=false;o.depends({type:'pump',subtype:'pump'});o.depends({type:'pump',subtype_pump:'pump'});o.value('',_('Select Pump Model'));for(var j=0;j<pump_models.length;j++){o.value(pump_models[j].toLowerCase().replace(/ /g,'_'),pump_models[j]);}
o.cfgvalue=function(section_id){return uci.get('machines',section_id,'pump_model');}
o.onchange=function(ev,section_id,value){if(value!=''){this.map.save(function(){uci.set('machines',section_id,'pump_model',value);}).then(()=>{setTimeout(function(){fireLoadingScripts();},1000);});}};o.validate=function(section_id,value){if((uci.get('machines',section_id,'manufacturer_type')=='retrofit')&&value==''&&uci.get('machines',section_id,'type')&&uci.get('machines',section_id,'subtype')){return _('Select Pump Model');}else{return true;}}
o=s.option(form.Value,'part_number',_('Part Number'));o.modalonly=false;o.load=function(section_id){}
o.cfgvalue=function(section_id){return uci.get('machines',section_id,'part_number');}
o.depends({type:'pump',subtype:'pump'});o.depends({type:'pump',subtype_pump:'pump'});o=s.option(form.TextValue,'description',_('Description'));o.modalonly=false;o.rows=4;o.load=function(section_id){}
o.cfgvalue=function(section_id){return uci.get('machines',section_id,'description');}
o.depends('type','pump');o=s.option(form.DummyValue,"__sensor",_("Sensors"));o.modalonly=false;o.cfgvalue=function(section_id){var m2,s2,o2;m2=new form.Map('machines');m2.readonly=!L.hasViewPermission();s2=m2.section(form.TypedSection,'sensor');s2.anonymous=true;s2.addremove=true;s2.addbtntitle=_('Add Sensor');var machine_id=uci.get('machines',section_id,'id');var machine_type=uci.get('machines',section_id,'type');var machine_subtype=uci.get('machines',section_id,'subtype');s2.cfgsections=function(section_id){var sensors=uci.sections('machines','sensor');var sections=[];for(var i=0;i<sensors.length;i++){if(sensors[i]['machine']==machine_id)
sections.push(sensors[i]['.name']);}
return sections;}
s2.handleAdd=function(ev){if(!machine_type||machine_type==''){return false;}
return this.map.save(L.bind(function(){var newSensor=uci.add('machines','sensor');uci.set('machines',newSensor,'machine',machine_id);if(machine_type=='power'){uci.set('machines',newSensor,'mac',fullMac.toUpperCase());if(machine_subtype!='vfdsense'){uci.set('machines',newSensor,'type','PF');}else{var sensors=uci.sections('machines','sensor');var vfdsense_sensors=sensors.filter(function(s){return s.type&&(s.type.toLowerCase()=='vfdi'||s.type.toLowerCase()=='vfdo');});var port=1;if(vfdsense_sensors.length==2){port=3;}
if(vfdsense_sensors.length==4){uci.remove('machines',newSensor);return;}
var newSensor2=uci.add('machines','sensor');uci.set('machines',newSensor,'type','PF');uci.set('machines',newSensor,'port',port);uci.set('machines',newSensor,'io_type','input');uci.set('machines',newSensor,'name','PF_'+port);uci.set('machines',newSensor2,'mac',fullMac.toUpperCase());uci.set('machines',newSensor2,'machine',machine_id);uci.set('machines',newSensor2,'type','PF');uci.set('machines',newSensor2,'port',port+1);uci.set('machines',newSensor2,'io_type','output');uci.set('machines',newSensor2,'name','PF_'+(port+1));}}
if(machine_type=='plc'){var sensors=uci.sections('machines','sensor');var plc_sensors=sensors.filter(function(s){return s.type&&s.type.toLowerCase()=='plc';});if(plc_sensors.length==0){uci.set('machines',newSensor,'type','PLC');uci.set('machines',newSensor,'port','1');uci.set('machines',newSensor,'name','PLC_1');updateSensorID(newSensor,'','PLC',1);}else{var cda_sensors=sensors.filter(function(s){return s.type&&s.type.toLowerCase()=='cda';});var new_port=cda_sensors.length+1;uci.set('machines',newSensor,'type','CDA');uci.set('machines',newSensor,'port',new_port);uci.set('machines',newSensor,'name','CDA_'+new_port);}
uci.set('machines',newSensor,'mac',fullMac.toUpperCase());}},this)).then(()=>{fireLoadingScripts();fireSensorScripts();});};s2.handleRemove=function(section_id,ev){return form.TypedSection.prototype.handleRemove.apply(this,[section_id,ev]).then(()=>{fireLoadingScripts();fireSensorScripts();});}
s2.saveValueAndUpdate=function(self,ev,section_id,value,setting,fields){var canSave=true;for(var i=0;i<fields.length;i++){if(fields[i]!=setting&&!uci.get('machines',section_id,fields[i])){canSave=false;}}
if(canSave){self.map.save(function(){uci.set('machines',section_id,setting,value);var port=uci.get('machines',section_id,'port');var index=uci.get('machines',section_id,'index');var update=port?port:index;var type=uci.get('machines',section_id,'type');updateSensorID(section_id,'',type,update);}).then(()=>{fireSensorScripts();});}else{uci.set('machines',section_id,setting,value);}
fireSensorScripts();}
if(machine_type=='rail'){o2=s2.option(form.ListValue,'type',_('Type'));o2.value('',_('Select Sensor Type'));o2.value('VAC',_('VAC'));o2.value('ST',_('ST'));o2.value('PS',_('PS'));o2.optional=false;o2.onchange=function(ev,section_id,value){s2.saveValueAndUpdate(this,ev,section_id,value,'type',st_fields);}
o2.validate=function(section_id,value){if(value==''){return _('Sensor Type is required');}else{return true;}}}
if(machine_type=='pump'){o2=s2.option(form.ListValue,'type',_('Type'));o2.value('',_('Select Sensor Type'));o2.value('VAC',_('VAC'));o2.value('ST',_('ST'));o2.optional=false;o2.onchange=function(ev,section_id,value){s2.saveValueAndUpdate(this,ev,section_id,value,'type',pump_fields);}
o2.validate=function(section_id,value){if(value==''){return _('Sensor Type is required');}else{return true;}}}
if(machine_type=='plc'){o2=s2.option(form.ListValue,'type',_('Type'));o2.value('',_('Select Sensor Type'));o2.value('PLC',_('PLC'));o2.value('CDA',_('CDA'));o2.optional=false;o2.onchange=function(ev,section_id,value){this.map.save(function(){uci.set('machines',section_id,'type',value);updateSensorID(section_id,'',value);});}}
if(machine_type=='pump'||machine_type=='rail'){o2=s2.option(form.Value,'mac',_('MAC'));o2.modalonly=false;o2.optional=false;o2.onchange=function(ev,section_id,value){if(machine_type=='rail'){s2.saveValueAndUpdate(this,ev,section_id,value,'mac',st_fields);}else{var type=uci.get('machines',section_id,'type')||'';s2.saveValueAndUpdate(this,ev,section_id,value,'mac',pump_fields);}}
o2.validate=function(section_id,value){if(value==''){return _('MAC is required');}else{return true;}}}
o2=s2.option(form.DummyValue,'_scan_sensor_mac',"Scan");o2.modalonly=false;o2.optional=false;o2.cfgvalue=L.bind(function(section_id){var node=E('div',{'class':'scan-mac'},[E('button',{'class':'cbi-button cbi-button-action important','title':_('Scan BLE Devices'),'click':ui.createHandlerFn(s,'handleScan','mac',section_id)},_('Scan'))]);return node;},this);o2.depends('type','VAC');o2.depends('type','ST');o2.depends('type','PS');o2=s2.option(form.Value,'name',_('Name'));o2.modalonly=false;o2.optional=false;if(machine_type=='power'&&machine_subtype=='vfdsense'){o2=s2.option(form.ListValue,'io_type',_('IO Type'));o2.modalonly=false;o2.optional=false;o2.value('',_('Select IO Type'));o2.value('input',_('Input'));o2.value('output',_('Output'));o2.onchange=function(ev,section_id,value){s2.saveValueAndUpdate(this,ev,section_id,value,'io_type',power_fields);}
o2.validate=function(section_id,value){if(value==''&&uci.get('machines',section_id,'type'!='')){return _('Select IO Type');}else{return true;}}}
o2=s2.option(form.Value,'calib_a',_('Calib A'));o2.modalonly=false;o2.depends('type','VAC');o2=s2.option(form.Value,'calib_b',_('Calib B'));o2.modalonly=false;o2.depends('type','VAC');o2=s2.option(form.HiddenValue,'type');o2.modalonly=false;if(machine_type=='rail'){o2=s2.option(form.ListValue,'index',_('Index'));o2.modalonly=false;o2.optional=false;o2.depends('type','ST');o2.value('',_('Select Index'));o2.value('1',_('1'));o2.value('2',_('2'));o2.onchange=function(ev,section_id,value){s2.saveValueAndUpdate(this,ev,section_id,value,'index',st_fields);}
o2.validate=function(section_id,value){if(value==''){return _('Select Index');}else{return true;}}}
o2=s2.option(form.ListValue,'port',_('Port'));o2.modalonly=false;o2.optional=false;o2.depends('type','PF');o2.depends('type','PLC');o2.depends('type','CDA');o2.depends('type','VFDI');o2.depends('type','VFDO');o2.value('',_('Select Port'));o2.value('1',_('1'));o2.value('2',_('2'));o2.value('3',_('3'));o2.value('4',_('4'));if(machine_type=='plc'){for(var i=5;i<=49;i++){o2.value(i,_(''+i));}}
o2.onchange=function(ev,section_id,value){if(machine_type=='power'){s2.saveValueAndUpdate(this,ev,section_id,value,'port',power_fields);}
if(machine_type=='plc'){s2.saveValueAndUpdate(this,ev,section_id,value,'port',plc_fields);}}
o2.validate=function(section_id,value){if(value==''){return _('Select Port');}else{return true;}}
o2=s2.option(form.ListValue,'phasetype',_('Phase Type'));o2.modalonly=false;o2.optional=false;o2.depends('type','PF');o2.depends('type','VFDI');o2.depends('type','VFDO');o2.value('',_('Select Phase Type'));o2.value('Single',_('Single'));o2.value('Three',_('Three'));o2.onchange=function(ev,section_id,value){s2.saveValueAndUpdate(this,ev,section_id,value,'phasetype',power_fields);}
o2.validate=function(section_id,value){if(value==''){return _('Select Phase Type');}else{return true;}}
o2=s2.option(form.ListValue,'cttype',_('CT Type'));o2.modalonly=false;o2.optional=false;o2.depends('type','PF');o2.depends('type','VFDI');o2.depends('type','VFDO');o2.value('',_('Select CT Type'));o2.value('50A',_('50A'));o2.value('100A',_('100A'));o2.value('200A',_('200A'));o2.value('300A',_('300A'));o2.value('600A',_('600A'));o2.value('1000A',_('1000A'));o2.value('2000A',_('2000A'));o2.onchange=function(ev,section_id,value){s2.saveValueAndUpdate(this,ev,section_id,value,'cttype',power_fields);}
o2.validate=function(section_id,value){if(value==''){return _('Select CT Type');}else{return true;}}
o2=s2.option(form.ListValue,'loadtype',_('Load Type'));o2.modalonly=false;o2.optional=false;o2.depends('type','PF');o2.depends('type','VFDI');o2.depends('type','VFDO');o2.value('',_('Select Load Type'));o2.value('Normal',_('Normal'));o2.value('Heater',_('Heater'));o2.value('Pre-VFD',_('Pre-VFD'));o2.value('Post-VFD',_('Post-VFD'));o2.value('Pre-Servo',_('Pre-Servo'));o2.value('Post-Servo',_('Post-Servo'));o2.onchange=function(ev,section_id,value){s2.saveValueAndUpdate(this,ev,section_id,value,'loadtype',power_fields);}
o2.validate=function(section_id,value){if(value==''){return _('Select Load Type');}else{return true;}}
o2=s2.option(form.ListValue,'isostat',_('Isolation'));o2.modalonly=false;o2.optional=false;o2.depends('type','PF');o2.depends('type','VFDI');o2.depends('type','VFDO');o2.value('',_('Select Isolation'));o2.value('Yes',_('Yes'));o2.value('No',_('No'));o2.onchange=function(ev,section_id,value){s2.saveValueAndUpdate(this,ev,section_id,value,'isostat',power_fields);}
o2.validate=function(section_id,value){if(value==''){return _('Select Isolation');}else{return true;}}
return m2.render().then(L.bind(function(nodes){var machines=uci.sections('machines','machine');var powerMachines=machines.filter(function(machine){return machine.type=='power';});var sensors=uci.sections('machines','sensor');var powerSensors=[];for(var i=0;i<powerMachines.length;i++){for(var j=0;j<sensors.length;j++){if(sensors[j]['machine']==powerMachines[i].id){if(powerSensors[powerMachines[i].id]==undefined){powerSensors[powerMachines[i].id]=[];}
powerSensors[powerMachines[i].id].push(sensors[j]);}}}
for(var machineId in powerSensors){for(var i=0;i<powerSensors[machineId].length;i++){var sensorEl=nodes.querySelector('#cbi-machines-'+powerSensors[machineId][i]['.name']);if(sensorEl){var portEl=sensorEl.querySelector('#cbi-machines-'+powerSensors[machineId][i]['.name']+'-port');var portOptions=portEl.querySelectorAll('option');if(portOptions){for(var j=0;j<portOptions.length;j++){if(portOptions[j].value!=powerSensors[machineId][i]['port']){for(var k=0;k<powerSensors[machineId].length;k++){if(portOptions[j].value==powerSensors[machineId][k]['port']){portOptions[j].disabled='disabled';}}}}}}}}
return nodes;}),this);}
return m.render().then(L.bind(function(nodes){this.pollFn=L.bind(function(){if(machineIdsFixed()){poll.remove(this.pollFn);this.pollFn=null;}},this);poll.add(this.pollFn,1);return nodes;},this));}});